const actions = {
    notify({ commit }, payload ){
            openerp.web.notification.do_warn("Atention", payload)
    },
    initPayment({ commit , dispatch}, payload){

        commit('setPaymentsInstance', payload)

        let promises =[
            dispatch('fetchPartners'),
            dispatch('fetchPaymentsJournal'),
            dispatch('fetchPaymentsCompany')
        ]

        Promise.all(promises).then(() => {
            console.log('loaded')
        }).catch(error => {
            console.log(error)
        })
    },
    // Validaciones
    checkPartner({getters, dispatch}) {
        return getters.hasSelectedPartner ||dispatch('notify', 'Nesesitas selecionar un cliente para continuar')
    },
    checkInvoice({getters, dispatch}){
        return getters.haSelectedInvoices || dispatch('notify', 'Nesesitas selecionar una factura para continuar')
    },
    checkMoveLine({getters, dispatch}) {
        return getters.moveLinesIsEmpty ||dispatch('notify', 'Necesitas seleccionar la cuota para continuar')
    },
    chekPaymentAmount({getters,dispatch}) {
        return getters.paymentAmount > 0 || dispatch('notify', 'Nesesitas ingresar un monto a pagar ')
    },
    // Finalizar operacion
    completePayment({ dispatch, getters, state}) {
        let newObjet = []

        return new Promise((resolve, reject) => {
            let AccountVoucher = new openerp.web.Model('account.voucher')

            AccountVoucher.call('create_from_payments',[
                {
                    reference : getters.selectedInvoices.number,
                    journal_id : getters.selectedPaymentsJournals.id,
                    company : getters.paymentsCompany.id,
                    amount : getters.paymentAmount <= getters.total ? getters.paymentAmount : getters.total,
                    partner_id : getters.selectedPartner.id,
                    invoice: getters.selectedInvoices.id,
                    line_cr_ids : getters.addMove.map(item => {
                        return  item.id
                    })
                }
            ],{
                context: new openerp.web.CompoundContext()
            }).then(response => {
                window.location.reload()

                dispatch('printPayments', response)

                resolve(response)
            }).fail(error => {
                console.log(error)
                reject(error)
            })
        })
    },
    printPayments({ getters, dispatch },payload) {
        let self = getters.getPaymentsInstance

        let active_ids = {
            active_id: payload.voucher_id,
            active_ids: [payload.voucher_id],
            active_model: 'account.voucher'
        }

        self.rpc('/web/action/load',{
            action_id: payload.action_id,
            context: new openerp.web.CompoundContext(active_ids).eval()
        }).then(result => {
            result.context = new openerp.web.CompoundContext(active_ids).eval()
            result.flags = result.flags || {}
            result.flags.new_window = true

            self.do_action(result,{
                on_close: function () {
                    self.getParent().reload()
                }
            })
        })
    }
}

export default actions
