import Vue from 'vue'
import Vuex from 'vuex'

import state from '@/store/state'
import getters from '@/store/getters'
import actions from '@/store/actions'
import mutations from '@/store/mutations'
// Modules
import paymentsPartners from '@/store/modules/paymentsPartners'
import paymentsInvoices from '@/store/modules/paymentsInvoices'
import paymentsMoveLines from '@/store/modules/paymentsMoveLines'
import paymentsJournal from '@/store/modules/paymentsJournal'
import paymentsCompany from '@/store/modules/paymentsCompany'
import paymentsLoader from '@/store/modules/paymentsLoader'

Vue.use(Vuex)

const Store = new Vuex.Store({
    state,
    getters,
    mutations,
    actions,
    modules:{
        paymentsPartners,
        paymentsInvoices,
        paymentsMoveLines,
        paymentsJournal,
        paymentsCompany,
        paymentsLoader
    }
})

export default Store
