const state = {
    paymentsJournals: [],
    selectedPaymentsJournals : null,
    paymentAmount: 0
}

const getters = {
    paymentsJournals(state) {
        return state.paymentsJournals
    },
    selectedPaymentsJournals(state) {
        return state.selectedPaymentsJournals
    },
    paymentAmount(state){
        return state.paymentAmount
    }
    // paymentsJournalsSymbol(state) {
    //
    //     // console.log();
    //     // console.log(state.selectedPaymentsJournals.currency);\
    //     // return state.selectedPaymentsJournals.currency.symbol ? state.selectedPaymentsJournals.currency.symbol : state.companySymbol
    // }
}

const mutations = {
    pushPaymentsJournal(state, payload) {
        state.paymentsJournals = [...payload.paymentsJournals]
    },
    setSelectPaymentsJournal(state, payload) {
        state.selectedPaymentsJournals = payload
    },
    changePaymentAmount(state, payload) {
        state.paymentAmount = payload
    }
}

const actions = {
    fetchPaymentsJournal({ commit, dispatch}) {
        return new Promise((resolve, reject) => {
            let Accountjournal = new openerp.web.Model('account.journal')

            Accountjournal.call('get_paymentsJournals',{
                context: new openerp.web.CompoundContext()
            }).then(response => {
                commit('pushPaymentsJournal',{
                    paymentsJournals: response
                })

                dispatch('autoSelectPaymentsJournal', response)

                dispatch('loaded', 'paymentsJournals')

                resolve()
            }).fail(error => {
                console.error(error)
                reject(error)
            })
        })
    },
    autoSelectPaymentsJournal ({ dispatch }, payload ) {
        dispatch('selectPaymentsJournal', payload.find(j => j.type === 'cash'))
    },
    selectPaymentsJournal({ commit}, payload) {
        commit('setSelectPaymentsJournal', payload)

        commit('changePaymentAmount', 0)

    },
    changePaymentAmount({ commit }, payload) {
        commit('changePaymentAmount', payload)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
