const state = {
    moveLines: [],
    movelineSelect: [],
    selectedMoveline: null,
    total: 0
}

const getters = {
    moveLines (state) {
        return state.moveLines
    },
    selectedMoveline(state) {
        return state.selectedMoveline
    },
    haSelectedMoveline(state) {
        return !!state.selectedMoveline
    },
    addMove(state) {
        return state.movelineSelect
    },
    total(state) {
        return state.total
    },
    moveLinesIsEmpty(state) {
        return state.movelineSelect.length !== 0
    }
}

const mutations = {
    pushMovelines (state, payload) {
        let move = payload.moveLines
        move.sort((a, b) => {
            return a.date_maturity > b.date_maturity
        })

        state.moveLines = move
    },
    selectMoveline(state, payload) {
        state.selectedMoveline = payload.moveline
    },
    addMoveline(state, payload) {
        let finded = state.movelineSelect.find(item => item.id == payload.moveselect.id)
        if (finded) return

        state.movelineSelect =[payload.moveselect, ...state.movelineSelect]

        state.movelineSelect.sort((a, b) => {
            return a.date_maturity > b.date_maturity
        })
    },

    calculateTotal(state) {
        let  sum = 0
        state.movelineSelect.forEach(item => {
            sum = sum + item.amount_residual
        })

        state.total = sum
    },
    removeLine(state, payload) {
        let findedMove = state.movelineSelect.findIndex(item => item.id == payload.movedelet.id)

        state.movelineSelect.splice(findedMove,1)
    },
    removeMoveCard(state, payload) {
        let findedMoveCard = state.moveLines.findIndex(item => item.id == payload.moveCardDelet.id)
        state.moveLines.splice(findedMoveCard,1)
    },

    addMovelineCard(state, payload) {
        let finded = state.moveLines.find(item => item.id == payload.moveLine.id)
        if (finded) return

        state.moveLines = [payload.moveLine, ...state.moveLines]

        state.moveLines.sort((a, b) => {
            return a.date_maturity > b.date_maturity
        })
    },
    addMoveCard(state, payload) {
        payload.moveLine.forEach(moveLine => {
            let finded = state.moveLines.find(item => item.id == moveLine.id)
            if (finded) return

            state.moveLines = [moveLine, ...state.moveLines]

            state.moveLines.sort((a, b) => {
                return a.date_maturity > b.date_maturity
            })
        })
    },
    remoMovelineSelectALL(state,payload) {
        state.movelineSelect.splice(0)
    }
}

const actions = {
    pushMovelines({ commit, dispatch}, payload ) {
        commit('pushMovelines', payload)
    },

    selectMoveline({ commit, dispatch, getters}, payload) {
        let dateMin = moment(moment.min(getters.moveLines.map(item => { return moment(item.date_maturity)}))).valueOf()

        if (dateMin < moment(payload.date_maturity).valueOf())
            return dispatch('notify', 'Cuota no permitida')
            // return dispatch('notify', 'Ops, no podes seleccionar esta cuota, debes seleccionar la cuota pendiente permitida')

        commit('selectMoveline',{
            moveline: payload
        })
        commit('addMoveline',{
            moveselect: payload
        })
        commit('removeMoveCard',{
            moveCardDelet: payload
        })
        commit('calculateTotal')
    },

    removeLine({ commit, dispatch, state}, payload) {

        let dateMax = moment(moment.max(state.movelineSelect.map(item => { return moment(item.date_maturity)}))).valueOf()

        if (dateMax > moment(payload.date_maturity).valueOf())
            return dispatch('notify', 'No podes eliminar esta cuota')
            // return dispatch('notify', 'Ops, no podes suprimir este registro, primero debes eliminar las cuota con fecha de vencimiento superior')

        commit('removeLine',{
            movedelet: payload
        })
        commit('addMovelineCard',{
            moveLine: payload
        })
        dispatch('addMovelineInvoice', {
            moveLine: payload
        })
        commit('calculateTotal')
    },

    removeLineAll({ commit, dispatch, state}, payload) {

        if (!payload) return

        if (state.movelineSelect.length === 0 ) return

        commit('addMoveCard',{
            moveLine: state.movelineSelect.map(item => {
                return item
            })
        })
        dispatch('addMovesInvoice',{
            moveLine: state.movelineSelect.map(item => {
                return item
            })
        })
        commit('remoMovelineSelectALL',state.movelineSelect)

        commit('calculateTotal')
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
